#ifndef _CONFIG_INC
#define _CONFIG_INC

#include <vector>
#include <string>

#include "automata.h"

using namespace std;

typedef enum {
	OPEN_SESSION,
	CLOSE_SESSION,
	SPACE_BR,
	NEW_PARTY,
	NEW_DEPUTY,
	
	NUM_CONFIG_SECTIONS
} CONFIG_SECTION;

extern vector<string> config_sections[NUM_CONFIG_SECTIONS];
extern Automata automata;

CONFIG_SECTION find_section(const char *s);
const char *str_section(const int section);
void read_config(const char *file);
bool check_string(CONFIG_SECTION section, const char *s);
void print_configuration();

#endif /* _CONFIG_INC */
