#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <iostream>
#include <string>
//#include <regex>

#include "config.h"
#include "process.h"

bool debug_mode = false;
int debug_line;

void usage(char **argv) {
	fprintf(stderr, "Configuration file is required. Please specify one.\n");
	fprintf(stderr, "Usage: %s conf_file.ini [--debug start_line] [input_file] ...\n", argv[0]);
	exit(EXIT_FAILURE);	// Exit with error
}

int main(int argc, char *argv[]) {
	int i;
	
	/*string a("Ola mundo");
	string b("Ola mundo cruel e estupido");
	
	printf("%s -- %s = %d\n",a.c_str(),b.c_str(),a.compare(0,a.size(),b.c_str(),0,a.size()));
	getchar();*/
	
	
	//std::cmatch res;
	//std::string str = "<h2>Egg prices</h2>";
	//std::regex rx("<h(.)>");
    //std::regex_search(str.c_str(), res, rx);
	//std::cout << res[1] << ". " << res[2] << "\n";
	
	//printf("%d\n",regex_match(str, rx));
	
	if(argc == 1)
		usage(argv);
	
	// Reads the configuration
	read_config(argv[1]);
	
	if(argc >= 3 && strcmp(argv[2],"--debug") == 0) {
		if(argc < 4) usage(argv);
		
		debug_mode = true;
		debug_line = atoi(argv[3]);
		printf("Debug mode activated. Starting from line number %d\n",debug_line);
		
		automata.print();
		print_configuration();
	}
	
	// Reads from standard input
	if(argc == (debug_mode ? 4 : 2)) {
		fputs("No input files specified, reading from standard input...\n",stderr);
		analyse(stdin);
	}
	
	// Reads from specified files
	for(i=(debug_mode ? 4 : 2);i<argc;i++) {
		FILE *file = fopen(argv[i], "r");
		if(file == NULL)
			fprintf(stderr,"Impossible to open file '%s'!\n",argv[i]);
		else {
			fprintf(stderr,"Processing '%s'...\n",argv[i]);
			analyse(file);
			fclose(file);
			fprintf(stderr,"Done!\n");
		}
	}
	
	return EXIT_SUCCESS;
}
