#include <stdio.h>
#include <string.h>

#include "process.h"
#include "config.h"

#define SIZE_BUFFER	100000

extern bool debug_mode;
extern int debug_line;

void analyse(FILE *file) {
	char buf[SIZE_BUFFER];
	
	int line_number = 0;
	string party;
	
	while(fgets(buf,SIZE_BUFFER,file)) {
		int buf_len = strlen(buf);	
		buf[--buf_len] = '\0';
		line_number++;	// next line
		
		// Previous state
		int prev_state = automata.state();
		
		// Apply the current line to the automata and calculate the jump
		int result = automata.apply(buf);
		
		switch(result) {
			case NEW_PARTY:
				if(buf[buf_len-1] == ':')	// Removes colon if present
					buf[--buf_len] = '\0';
				party = &buf[1];	// Assigns a new party
				break;
			case NEW_DEPUTY:
				if(buf[buf_len-1] != ':')	// If colon is present, means that something went wrong
					printf("%s # %s\n",party.c_str(),&buf[1]);
				break;
		}
		
		// Debug mode
		if(debug_mode && line_number >= debug_line) {
			fprintf(stderr,"%3d STATE:%d->%d\t %s\t%s\n",line_number,prev_state,automata.state(),str_section(result),buf);
			getchar();
		}
	}
}
